#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	clement
Version		:	2.8.1.7
Release		:	14.4.0.0%{?dist}
Summary		:	Application to filter and manage E-mail traffic
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2
URL		:	http://www.clement.safe.ca/index.html

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	binutils
BuildRequires	:	bison
BuildRequires	:	gcc
BuildRequires	:	gmp
BuildRequires	:	linux-headers
BuildRequires	:	m4
BuildRequires	:	make
BuildRequires	:	openldap-devel
BuildRequires	:	openssl-devel
BuildRequires	:	zlib-devel

Requires(pre)	:	/usr/sbin/useradd,/usr/sbin/userdel,/usr/sbin/usermod
Requires(post)	:	/usr/bin/dig

Requires	:	bc
Requires	:	binutils
Requires	:	clamd
Requires	:	coreutils
Requires	:	cpp
Requires	:	cronie
Requires	:	dejavu-fonts
Requires	:	dovecot-pigeonhole
Requires	:	expect
Requires	:	httpd
Requires	:	php-apache
Requires	:	procmail
Requires	:	logrotate
Requires	:	openssl
Requires	:	php		>= 8
Requires	:	procmail
Requires	:	rrdtool
Requires	:	spamassassin
Requires	:	which
Requires	:	whois
#-----------------------------------------------------------------------------
%description
'%{name}' is an email firewall. Its purpose is to filter all email,
rejecting viruses and unwelcome messages at the SMTP protocol level
(and avoids bouncing to forged originators).
It also provide audit logs, allowing effective mean to search about
email exchange within time and transaction context.

'%{name}' extracts "email sending contexts" and can use a remote mentor
process to further analyze message context while still connected to the
remote sender process.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc README
%attr(0755,root,root) %{_initrddir}/%{name}
%attr(0755,%{name},mail) %dir %{_sysconfdir}/%{name}
%attr(0755,%{name},mail) %config(noreplace) %{_sysconfdir}/%{name}/*
%{_sysconfdir}/pki/%{name}/*
%{_sysconfdir}/cron.d/%{name}
%{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/sysconfig/%{name}
%{_bindir}/clmailc
%{_bindir}/clmsndr
%{_bindir}/clmtrst
%{_bindir}/pibsmtp
%attr(0755,%{name},mail) %{_sbindir}/%{name}
%{_libdir}/%{name}/shell/*.sh
%{_libdir}/%{name}/support/*.sh
%{_libdir}/%{name}/support/dummy-cert
%{_libdir}/%{name}/utilities/*
%attr(0755,%{name},mail) %dir %{_var}/lib/%{name}
%attr(0755,%{name},mail) %dir %{_var}/lib/%{name}/stats
%attr(0755,%{name},mail) %dir %{_var}/log/%{name}
%attr(0755,%{name},mail) %dir %{_var}/lock/%{name}
%attr(0755,%{name},mail) %dir %{_var}/crash/%{name}
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/.spamassassin
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/dbgs
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/logs
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/logs/Old
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/mails
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/mqueue
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/tobesend
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/transit
%attr(0755,%{name},mail) %dir %{_var}/spool/%{name}/trblq
%attr(0755,%{name},mail) %dir %{_var}/www/%{name}/graph
%{_var}/www/%{name}/ChangeLog
%{_var}/www/%{name}/detail/.htaccess
%{_var}/www/%{name}/detail/detail.php
%{_var}/www/%{name}/java/*.{png,gif,js}
%{_var}/www/%{name}/lang/fr/*
%{_var}/www/%{name}/lang/en/*
%{_var}/www/%{name}/*.{html,php}
%{_var}/www/%{name}/reg-icons/%{name}.css
%{_var}/www/%{name}/web/ChangeLog
%{_var}/www/%{name}/web/%{name}.css
%{_var}/www/%{name}/web/faq.html
%{_var}/www/%{name}/web/*.php
%{_var}/www/%{name}/web/reg-icons/*.{gif,png}
%{_var}/www/%{name}/web/reg-icons/*.{jpg,xbm}
%{_var}/www/%{name}/reg-icons/*.gif

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_initrddir}/%{name} stop > /dev/null 2>&1 || :
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  /bin/echo "remaining file in this directory are data-base and logs"
  /bin/echo "created while %{name} was in production."
  /bin/echo "these files _may_ be removed too, but that they could"
  /bin/echo "contain valuable data and admin should be careful"
  /bin/echo "when removing them."
  ) > %{_var}/log/README-%{name}-removed
  /sbin/chkconfig --del %{name}
  %{_sbindir}/userdel %{name}
  fi

%pre
if [ "$1" = 1 ]; then
  %{_sbindir}/useradd 				\
	-r					\
	-c "%{name} daemon"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g mail					\
	-s /bin/bash				\
	-d %{_var}/spool/%{name}		\
	%{name}
  fi

%post
if [ "$1" = 1 ]; then
  (
  echo "#------------------------------------------"
  echo "#Architecture type was set by rpm first install procedure"
  echo "#"`date`
  echo "AP_ARCH=%{_arch}"
  echo "#------------------------------------------"
  ) >> %{_sysconfdir}/sysconfig/%{name}
  fi

/sbin/chkconfig --add %{name}

if [ "$1" = 2 ]; then
  if [ -f /var/lock/subsys/%{name} ] ; then
    export GOCLEM="GO"
    %{_initrddir}/%{name} stop 2>/dev/null || :
    fi 
  if [ -f /var/lock/subsys/dovecot ] ; then
    export GODOV="GO"
    %{_initrddir}/dovecot stop 2>/dev/null || :
    fi
  sleep 5         #waiting clement full shutdown
  %{_libdir}/%{name}/utilities/do_update.sh %{name}
  sleep 5         #waiting DB full shutdown
  if [ -n "$GODOV" ] ; then
    %{_initrddir}/dovecot start 2>/dev/null || :
    fi
  if [ -n "$GOCLEM" ] ; then
    %{_initrddir}/%{name} start 2>/dev/null || :
    fi
  if [ -f %{_usr}/lib/%{name}/shell/version.sh ] ; then
    cp -f %{_usr}/lib/%{name}/shell/version.sh  \
          %{_usr}/lib/%{name}/shell/prev-version.sh
    fi
  fi

#=============================================================================
%package		mysql
Summary		:	Clement+mysql Data-base

#-----------------------------------------------------------------------------
BuildRequires	:	mariadb

Requires	:	%{name}			=  %{version}-%{release}
Requires	:	mariadb
Requires	:	dovecot-mysql
Requires	:	php-mysqlnd

Conflicts	:	%{name}-postgresql
#-----------------------------------------------------------------------------
%description		mysql
'%{name}' is configured to work with MYSQL type database

#-----------------------------------------------------------------------------
%files			mysql

#-----------------------------------------------------------------------------
%preun			mysql
if [ "$1" = 0 ]; then
  sed -i						\
    -e 's/^DB_TYPE="MYSQLI"/#DB_TYPE="MYSQLI"/'	\
    %{_sysconfdir}/%{name}/%{name}.conf
  fi

%post			mysql
if [ "$1" = 1  -a -f %{_sysconfdir}/%{name}/%{name}.conf ]; then
  sed -i						\
    -e 's/^#DB_TYPE="MYSQLI"/DB_TYPE="MYSQLI"/'	\
    %{_sysconfdir}/%{name}/%{name}.conf
  fi

#=============================================================================
%package		postgresql
Summary		:	Clement+postgresql Data-base

#-----------------------------------------------------------------------------
BuildRequires	:	postgresql	>=  12

Requires	:	%{name}	=  %{version}-%{release}
Requires	:	postgresql-server
Requires	:	postgresql-contrib
Requires	:	dovecot-postgresql
Requires	:	openldap-clients
Requires	:	php-pgsql

Conflicts	:	%{name}-mysql
#-----------------------------------------------------------------------------
%description		postgresql
'%{name}' is configured to work with POSTGRESQL type database

#-----------------------------------------------------------------------------
%files			postgresql

#-----------------------------------------------------------------------------
%preun			postgresql
if [ "$1" = 0 ]; then
  sed -i						\
    -e 's/^DB_TYPE="POSTGRESQL"/#DB_TYPE="POSTGRESQL"/'	\
    %{_sysconfdir}/%{name}/%{name}.conf
  fi

%post			postgresql
if [ "$1" = 1  -a -f %{_sysconfdir}/%{name}/%{name}.conf ]; then
  sed -i						\
    -e 's/^#DB_TYPE="POSTGRESQL"/DB_TYPE="POSTGRESQL"/'	\
    %{_sysconfdir}/%{name}/%{name}.conf
  fi

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}
#overwriting dsitribution configuration file
%{__cp} -a						\
	%{name}-ok_addon/starting.sh			\
	%{name}-ok_addon/addconfig.sh			\
	support

#-----------------------------------------------------------------------------
#building application
%build

#adjusting data base definition
sed -i							\
  -e "s:'NaN':NULL:"					\
  conf/%{name}.tbl

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}					\
	prod


#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR="%{buildroot}"				\
	install

install -d %{buildroot}%{_initrddir} 
install -m0755 %{name}-ok_addon/%{name}			\
        %{buildroot}%{_initrddir}/%{name}

%{__rm} -f							\
        %{buildroot}%{_sysconfdir}/pki/%{name}/Start*	\
        %{buildroot}%{_sysconfdir}/pki/%{name}/startcom*\
        %{buildroot}%{_sysconfdir}/pki/%{name}/trusted*

%{__mkdir_p} %{buildroot}%{_var}/lock/%{name}

#adjusting trusted certificate
%{__cp} -a						\
	%{name}-ok_addon/safe_CA.pem			\
	%{buildroot}%{_sysconfdir}/pki/%{name}

%{__ln_s}						\
	./safe_CA.pem					\
	%{buildroot}%{_sysconfdir}/pki/%{name}/%{name}-trusted.pem

#=============================================================================
%changelog
